/*
 SignaturePad: A jQuery plugin for assisting in the creation of an HTML5 canvas
 based signature pad. Records the drawn signature in JSON for later regeneration.

 Dependencies: FlashCanvas 1.5, json2, jquery-1.3.2+

 @project ca.thomasjbradley.applications.signaturepad
 @author Thomas J Bradley <hey@thomasjbradley.ca>
 @link http://thomasjbradley.ca/lab/signature-pad
 @link http://github.com/thomasjbradley/signature-pad
 @copyright Copyright MMXI, Thomas J Bradley
 @license New BSD License
 @version 2.0.2
*/
(function(b){function B(l,q){function t(){b(a.typed,d).hide();r();g.bind("mousedown.signaturepad",function(c){u(c,this)});g.bind("mouseup.signaturepad",function(){o()});g.bind("mouseleave.signaturepad",function(){n||(n=setTimeout(function(){o();clearTimeout(n);n=false},200))});typeof this.ontouchstart!="undefined"&&g.each(function(){this.ontouchstart=function(c){c.preventDefault();u(c,this)};this.ontouchend=function(){o()};this.ontouchcancel=function(){o()}});b(a.clear,d).bind("click.signaturepad",
function(){r();return false});b(a.typeIt,d).bind("click.signaturepad",function(){v();return false});b(a.drawIt,d).unbind("click.signaturepad");b(a.drawIt,d).bind("click.signaturepad",function(){return false});b(a.typeIt,d).removeClass(a.currentClass);b(a.drawIt,d).addClass(a.currentClass);b(a.sig,d).addClass(a.currentClass);b(a.typeItDesc,d).hide();b(a.drawItDesc,d).show();b(a.clear,d).show()}function v(){r();g.unbind("mousedown.signaturepad");g.unbind("mouseup.signaturepad");g.unbind("mousemove.signaturepad");
g.unbind("mouseleave.signaturepad");b(a.clear,d).unbind("click.signaturepad");b(a.typed,d).show();b(a.drawIt,d).bind("click.signaturepad",function(){t();return false});b(a.typeIt,d).unbind("click.signaturepad");b(a.typeIt,d).bind("click.signaturepad",function(){return false});b(a.output,d).val("");b(a.drawIt,d).removeClass(a.currentClass);b(a.typeIt,d).addClass(a.currentClass);b(a.sig,d).removeClass(a.currentClass);b(a.drawItDesc,d).hide();b(a.clear,d).hide();b(a.typeItDesc,d).show()}function w(c){for(b(a.typed,
d).html(c.replace(/>/g,"&gt;").replace(/</g,"&lt;"));b(a.typed,d).width()>i.width;){c=b(a.typed,d).css("font-size").replace(/px/,"");b(a.typed,d).css("font-size",c-1+"px")}}function u(c,e){g.bind("mousemove.signaturepad",function(j){s(j,this)});if(typeof this.ontouchstart!="undefined"){g.each(function(){this.ontouchmove=function(j){s(j,this,x(this))}});s(c,e,x(e),1)}else s(c,e,null,1)}function o(){g.unbind("mousemove.signaturepad");typeof this.ontouchstart!="undefined"&&g.each(function(){this.ontouchmove=
null});h.x=null;h.y=null;k.length>0&&b(a.output,d).val(JSON.stringify(k))}function x(c){var e;e=b(document).scrollTop();var j=0,p,m,y;if(e>0){p=c.offsetTop-b(c).offset().top;b(document).scrollTop(0);j=c.offsetTop-b(c).offset().top;b(document).scrollTop(e)}e=b(document).scrollLeft();m=0;if(e>0){y=c.offsetLeft-b(c).offset().left;b(document).scrollLeft(0);m=c.offsetLeft-b(c).offset().left;b(document).scrollLeft(e)}return{top:p!=j?b(document).scrollTop():0,left:y!=m?b(document).scrollLeft():0}}function s(c,
e,j,p){var m=b(e).offset();clearTimeout(n);n=false;if(typeof c.changedTouches!="undefined"){e=Math.floor(c.changedTouches[0].pageX-m.left+j.left);c=Math.floor(c.changedTouches[0].pageY-m.top+j.top)}else{e=Math.floor(c.pageX-m.left);c=Math.floor(c.pageY-m.top)}if(!(h.x==e&&h.y==c)){if(h.x===null)h.x=e;if(h.y===null)h.y=c;if(p)c+=p;f.beginPath();f.moveTo(h.x,h.y);f.lineTo(e,c);f.lineCap=a.penCap;f.stroke();f.closePath();k.push({lx:e,ly:c,mx:h.x,my:h.y});h.x=e;h.y=c}}function r(){o();f.clearRect(0,0,
i.width,i.height);if(!a.displayOnly){f.beginPath();f.lineWidth=a.lineWidth;f.strokeStyle=a.lineColour;f.moveTo(a.lineMargin,a.lineTop);f.lineTo(i.width-a.lineMargin,a.lineTop);f.stroke();f.closePath()}f.lineWidth=a.penWidth;f.strokeStyle=a.penColour;b(a.output,d).val("");k=[]}function z(){var c=true;b("p."+a.errorClass,d).remove();d.removeClass(a.errorClass);b("input, label",d).removeClass(a.errorClass);if(a.drawOnly&&k.length<1){b(l).prepend('<p class="'+a.errorClass+'">'+a.errorMessageDraw+"</p>");
c=false}if(b(a.name,d).val()===""){b(l).prepend('<p class="'+a.errorClass+'">'+a.errorMessage+"</p>");b(a.name,d).focus();b(a.name,d).addClass(a.errorClass);b("label[for="+b(a.name).attr("id")+"]",d).addClass(a.errorClass);c=false}return c}var A=this,a=b.extend({},b.fn.signaturePad.defaults,q),d=b(l),g=b(a.canvas,d),i=g.get(0),f=null,h={x:null,y:null},k=[],n=false;b(a.typed,d).bind("selectstart.signaturepad",function(c){return b(c.target).is(":input")});g.bind("selectstart.signaturepad",function(c){return b(c.target).is(":input")});
i.getContext||FlashCanvas.initElement(i);if(i.getContext){f=i.getContext("2d");b(a.sig,d).show();if(!a.displayOnly){if(!a.drawOnly){b(a.name,d).bind("keyup.signaturepad",function(){w(b(this).val())});b(a.name,d).bind("blur.signaturepad",function(){w(b(this).val())});b(a.drawIt,d).bind("click.signaturepad",function(){t();return false})}a.drawOnly||a.defaultAction=="drawIt"?t():v();if(a.validateFields)b(l).is("form")?b(l).bind("submit.signaturepad",function(){return z()}):b(l).parents("form").bind("submit.signaturepad",
function(){return z()});b(a.typeItDesc,d).show();b(a.sigNav,d).show()}}b.extend(A,{regenerate:function(c){A.clearCanvas();b(a.typed,d).hide();if(typeof c==="string")c=JSON.parse(c);for(var e in c)if(typeof c[e]==="object"){f.beginPath();f.moveTo(c[e].mx,c[e].my);f.lineTo(c[e].lx,c[e].ly);f.lineCap=a.penCap;f.stroke();f.closePath();k.push({lx:c[e].lx,ly:c[e].ly,mx:c[e].mx,my:c[e].my})}b(a.output,d).length>0&&b(a.output,d).val(JSON.stringify(k))},clearCanvas:function(){r()},getSignature:function(){return k},
getSignatureString:function(){return JSON.stringify(k)},getSignatureImage:function(){return i.toDataURL()}})}b.fn.signaturePad=function(l){var q=null;this.each(function(){q=new B(this,l)});return q};b.fn.signaturePad.defaults={defaultAction:"typeIt",displayOnly:false,drawOnly:false,canvas:"canvas",sig:".sig",sigNav:".sigNav",bgColour:"#fff",penColour:"#145394",penWidth:2,penCap:"round",lineColour:"#ccc",lineWidth:2,lineMargin:5,lineTop:35,name:".name",typed:".typed",clear:".clearButton",typeIt:".typeIt a",
drawIt:".drawIt a",typeItDesc:".typeItDesc",drawItDesc:".drawItDesc",output:".output",currentClass:"current",validateFields:true,errorClass:"error",errorMessage:"Please enter your name",errorMessageDraw:"Please sign the document"}})(jQuery);
